Home | History | Annotate | Download | only in docs
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (C) 2012 The Android Open Source Project
      5 #
      6 # Licensed under the Apache License, Version 2.0 (the "License");
      7 # you may not use this file except in compliance with the License.
      8 # You may obtain a copy of the License at
      9 #
     10 #      http://www.apache.org/licenses/LICENSE-2.0
     11 #
     12 # Unless required by applicable law or agreed to in writing, software
     13 # distributed under the License is distributed on an "AS IS" BASIS,
     14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     15 # See the License for the specific language governing permissions and
     16 # limitations under the License.
     17 #
     18 
     19 #
     20 # Generate all files we have templates for:
     21 #   docs.html
     22 #   ../src/camera_metadata_tag_info.c
     23 #   ../src/camera_metadata_tags.h
     24 #   ../../../../frameworks/av/camera/ndk/include/camera/NdkCameraMetadataTags.h
     25 #   ../../../../frameworks/av/camera/ndk/impl/ACameraMetadata.cpp
     26 #   ../../../../cts/tests/camera/src/android/hardware/camera2/cts/CaptureResultTest.java
     27 #   ../../../../frameworks/base/core/java/android/hardware/camera2/CameraCharacteristics.java
     28 #   ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureRequest.java
     29 #   ../../../../frameworks/base/core/java/android/hardware/camera2/CaptureResult.java
     30 
     31 if [[ -z $ANDROID_BUILD_TOP ]]; then
     32     echo "Please source build/envsetup.sh before running script" >& 2
     33     exit 1
     34 fi
     35 
     36 thisdir=$(cd "$(dirname "$0")"; pwd)
     37 fwkdir="$ANDROID_BUILD_TOP/frameworks/base/core/java/android/hardware/camera2/"
     38 fwkdir_html="$ANDROID_BUILD_TOP/frameworks/base/docs/html/reference"
     39 ndkdir_html="$ANDROID_BUILD_TOP/frameworks/native/docs"
     40 hidldir="$ANDROID_BUILD_TOP/hardware/interfaces/camera/metadata"
     41 ctsdir="$ANDROID_BUILD_TOP/cts/tests/camera/src/android/hardware/camera2/cts"
     42 outdir="$ANDROID_PRODUCT_OUT/obj/ETC/system-media-camera-docs_intermediates"
     43 ndk_header_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/include/camera"
     44 ndk_impl_dir="$ANDROID_BUILD_TOP/frameworks/av/camera/ndk/impl"
     45 device_info_dir="$ANDROID_BUILD_TOP/cts/tools/cts-device-info/"`
     46         `"src/com/android/cts/deviceinfo"
     47 out_files=()
     48 
     49 function relpath() {
     50     python -c "import os.path; print os.path.relpath('$1', '$PWD')"
     51 }
     52 
     53 # Generates a file. Appends to $out_files array as a side effect.
     54 function gen_file() {
     55     local in=$thisdir/$1
     56     local out=$thisdir/$2
     57 
     58     gen_file_abs "$in" "$out"
     59     return $?
     60 }
     61 
     62 function gen_file_abs() {
     63     local in="$1"
     64     local out="$2"
     65     local intermediates="$3"
     66     local hal_version="${4:-3.2}"
     67     local spec_file=$thisdir/metadata_definitions.xml
     68 
     69     python $thisdir/metadata_parser_xml.py $spec_file $in $out $hal_version
     70 
     71     local succ=$?
     72 
     73     if [[ $succ -eq 0 ]]
     74     then
     75         echo "OK: Generated $(relpath "$out")"
     76         if [[ "$intermediates" != "no" ]]; then
     77           out_files+=$'\n'" $out"
     78         fi
     79     else
     80         echo "FAIL: Errors while generating $(relpath "$out")" >& 2
     81     fi
     82 
     83     return $succ
     84 }
     85 
     86 # Print a list of git repository paths which were affected after file generation
     87 function affected_git_directories() {
     88     local input_files=($@)
     89     local git_directories=()
     90 
     91     for file in "${input_files[@]}"; do
     92         local dir_path="$(dirname "$file")"
     93         echo "Trying to cd into $dir_path" >& /dev/null
     94         # Absolute path to the git repository root of that file
     95         local git_path="$(cd "$dir_path";
     96                           git rev-parse --show-toplevel 2> /dev/null)"
     97         if [[ $? -eq 0 ]]; then
     98             # Both staged and unstaged changes
     99             local diff_result="$(cd "$dir_path";
    100                                  git status --porcelain | egrep -c -v '^[?][?]')"
    101             echo "Diff result was $diff_result" >& /dev/null
    102             echo "Diff result was $diff_result" >& /dev/null
    103             if [[ $diff_result -eq 0 ]]; then
    104                 echo "No changes in ${git_path}" >& /dev/null
    105             else
    106                 echo "There are changes in ${git_path}" >& /dev/null
    107                 git_directories+=("$git_path")
    108             fi
    109         fi
    110     done
    111 
    112     # print as result the unique list of git directories affected
    113     printf %s\\n "${git_directories[@]}" | sort | uniq
    114 }
    115 
    116 # Insert a file into the middle of another, starting at the line containing the
    117 # start delim and ending on the end delim, both of which are replaced
    118 function insert_file() {
    119     local src_part="$1"
    120     local dst_file="$2"
    121     local start_delim="/*@O~"
    122     local end_delim="~O@*/"
    123 
    124     local start_line="$(grep -n -F "${start_delim}" "${dst_file}" | cut -d: -f1)"
    125     local end_line="$(grep -n -F "${end_delim}" "${dst_file}" | cut -d: -f1)"
    126 
    127     # Adjust cutoff points to use start/end line from inserted file
    128     (( start_line-- ))
    129     (( end_line++ ))
    130 
    131     # Do some basic sanity checks
    132 
    133     if [[ -z "$start_line" ]]; then
    134        echo "No starting delimiter found in ${dst_file}" >& 2
    135        echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
    136        return 1
    137     fi
    138 
    139     if [[ -z "$end_line" ]]; then
    140        echo "No ending delimiter found in ${dst_file}" >& 2
    141        echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
    142        return 1
    143     fi
    144 
    145     if [[ "$start_line" -ge "$end_line" ]]; then
    146        echo "Starting delim later than ending delim: $start_line vs $end_line" >& 2
    147        echo "FAIL: Errors in inserting into $(relpath ${dst_file})" >& 2
    148        return 1
    149     fi
    150 
    151     local tmp_name=$(mktemp -t XXXXXXXX)
    152 
    153     # Compose the three parts of the final file together
    154 
    155     head -n "$start_line" "${dst_file}" > "${tmp_name}"
    156     cat "${src_part}" >> "${tmp_name}"
    157     tail -n "+${end_line}" "${dst_file}" >> "${tmp_name}"
    158 
    159     # And replace the destination file with the new version
    160 
    161     mv "${tmp_name}" "${dst_file}"
    162     echo "OK: Inserted $(relpath "$src_part") into $(relpath "$dst_file")"
    163     out_files+=$'\n'" $dst_file"
    164 }
    165 
    166 # Recursively copy a directory tree from $1 to $2. Pretty-prints status.
    167 function copy_directory() {
    168     local src="$thisdir/$1" # Relative to directory of this script
    169     local dst="$2" # Absolute path
    170 
    171     if ! [[ -d $src ]]; then
    172         echo "FAIL: Source directory $src does not exist" >& 2
    173         return 1
    174     fi
    175     if ! [[ -d $dst ]]; then
    176         echo "FAIL: Destination directory $dst does not exist" >& 2
    177         return 1
    178     fi
    179 
    180     cp -R "$src" "$dst"
    181     local retval=$?
    182 
    183     if [[ $retval -ne 0 ]]; then
    184         echo "ERROR: Failed to copy $(relpath "$src") to $(relpath "$dst")" >& 2
    185     else
    186         echo "OK: Copied $(relpath "$src") to $(relpath "$dst")"
    187         out_files+=$'\n'" $dst"
    188     fi
    189 
    190     return $retval
    191 }
    192 
    193 $thisdir/metadata-check-dependencies || exit 1
    194 $thisdir/metadata-validate $thisdir/metadata_definitions.xml || exit 1
    195 $thisdir/metadata-parser-sanity-check || exit 1
    196 
    197 # Generate HTML properties documentation
    198 gen_file html.mako docs.html || exit 1
    199 
    200 # Generate C API headers and implementation
    201 gen_file camera_metadata_tag_info.mako ../src/camera_metadata_tag_info.c || exit 1
    202 gen_file camera_metadata_tags.mako ../include/system/camera_metadata_tags.h || exit 1
    203 
    204 # Generate HIDL metadata modules - new versions need to be added here manually
    205 mkdir -p "${hidldir}/3.2"
    206 gen_file_abs HidlMetadata.mako "$hidldir/3.2/types.hal" yes 3.2 || exit 1
    207 mkdir -p "${hidldir}/3.3"
    208 gen_file_abs HidlMetadata.mako "$hidldir/3.3/types.hal" yes 3.3 || exit 1
    209 
    210 #Generate NDK header
    211 gen_file_abs ndk_camera_metadata_tags.mako "$ndk_header_dir/NdkCameraMetadataTags.h" yes || exit 1
    212 
    213 # Generate Java API definitions
    214 mkdir -p "${outdir}"
    215 gen_file_abs CameraMetadataEnums.mako "$outdir/CameraMetadataEnums.java.part" no || exit 1
    216 gen_file_abs CameraCharacteristicsKeys.mako "$outdir/CameraCharacteristicsKeys.java.part" no || exit 1
    217 gen_file_abs CaptureRequestKeys.mako "$outdir/CaptureRequestKeys.java.part" no || exit 1
    218 gen_file_abs CaptureResultKeys.mako "$outdir/CaptureResultKeys.java.part" no || exit 1
    219 
    220 insert_file "$outdir/CameraMetadataEnums.java.part" "$fwkdir/CameraMetadata.java" || exit 1
    221 insert_file "$outdir/CameraCharacteristicsKeys.java.part" "$fwkdir/CameraCharacteristics.java" || exit 1
    222 insert_file "$outdir/CaptureRequestKeys.java.part" "$fwkdir/CaptureRequest.java" || exit 1
    223 insert_file "$outdir/CaptureResultKeys.java.part" "$fwkdir/CaptureResult.java" || exit 1
    224 
    225 # Generate CTS test code
    226 gen_file_abs CaptureResultTest.mako "$outdir/CaptureResultTest.java.part" no || exit 1
    227 insert_file "$outdir/CaptureResultTest.java.part" "$ctsdir/CaptureResultTest.java" || exit 1
    228 
    229 # Generate NDK implementation
    230 gen_file_abs ACameraMetadata.mako "$outdir/ACameraMetadata.cpp.part" no || exit 1
    231 insert_file "$outdir/ACameraMetadata.cpp.part" "$ndk_impl_dir/ACameraMetadata.cpp" || exit 1
    232 
    233 # Generate CameraDeviceInfo code
    234 gen_file_abs CameraDeviceInfo.mako "$outdir/CameraDeviceInfo.java.part" no || exit 1
    235 insert_file "$outdir/CameraDeviceInfo.java.part" "$device_info_dir/CameraDeviceInfo.java" || exit 1
    236 
    237 # Generate protocol buffer definition corresponding to CameraDeviceInfo
    238 gen_file camera_device_info.mako ./camera_device_info.proto || exit 1
    239 
    240 # Copy ./images directory into javadoc directory
    241 copy_directory "images" "$fwkdir_html" || exit 1
    242 
    243 # Copy ./images directory into ndk doc directory
    244 copy_directory "images" "$ndkdir_html" || exit 1
    245 
    246 echo ""
    247 echo "===================================================="
    248 echo "Successfully generated all metadata source files"
    249 echo "===================================================="
    250 echo ""
    251 
    252 echo "****************************************************"
    253 echo "The following git repositories need to be committed:"
    254 echo "****************************************************"
    255 echo ""
    256 affected_git_directories "${out_files[@]}"
    257 echo ""
    258 
    259 exit 0
    260